/*
 * spi_bsp.h
 *
 *  Created on: Aug 2, 2023
 *      Author: hussamaldean
 */

#ifndef SPI_BSP_H_
#define SPI_BSP_H_

#include "stdint.h"
#include "stm32f4xx.h"



typedef enum
{
	spi1=0,
	spi2=1,
	spi3=2,
	spi4=3,
	spi5=4
}SPI_EnableTypedef;


typedef enum
{
	SPI_Succuss=0,
	SPI_Timeout=1,

}SPI_StatusTypedef;

typedef enum
{
	eight_bit=0,
	sixteen_bit=1,

	software_slave=1,
	hardware_slave=0,

	LSB_First=1,
	MSB_First=0,

	FCLK_2=0,
	FCLK_4=1,
	FCLK_8=2,
	FCLK_16=3,
	FCLK_32=4,
	FCLK_64=5,
	FCLK_128=6,
	FCLK_256=7,

	Master_mode=1,
	Slave_mode=0,

	CPOL0=0,
	CPOL1=1,

	CPHA0=0,
	CPHA1=1,

}SPI_ConfigurationTypedef;


typedef enum
{
	SPI_DMA_Disabled=0,
	SPI_DMA_Enable=1

}SPI_DMATypedef;


typedef struct
{
	uint8_t mode;
	uint8_t dataFromat;
	uint8_t slaveManagement;
	uint8_t LSBFirst;
	uint8_t baud;
	uint8_t CPOL;
	uint8_t CPHA;
	uint8_t DMA_Enable;
}SPI_ConfigTypedef;


void SPI_Enable_Clock(SPI_EnableTypedef spi_number);

void BSP_SPI_Config(SPI_TypeDef *spi, SPI_ConfigTypedef *con);

SPI_StatusTypedef BSP_SPI_Transmit(SPI_TypeDef *spi ,uint8_t *data,uint32_t size, uint32_t timeout);

SPI_StatusTypedef BSP_SPI_Receive(SPI_TypeDef *spi ,uint8_t *data,uint32_t size, uint32_t timeout);


#endif /* SPI_BSP_H_ */
