#include "bsp.h"
#include "uart_bsp.h"
#include "exti_bsp.h"
#include "bsp_debug.h"
#include "spi_bsp.h"
#include "dma_bsp.h"

#include "stdlib.h"

void clock_config(void);

volatile uint8_t finished=0;


uint8_t SPI_TX[5]={0x00,0x22,0xFF,0x55,0x33};



DMA_ConfigTypedef SPI_TX_DMA;
GPIO_Output_Typedef CS_Pin;


int main()
{


	#if FPU_EN
		SCB->CPACR |= ((3UL << 10*2)|(3UL << 11*2));
	#endif

	clock_config();
	BSP_Ticks_Init(100000000);

	GPIO_Configure_Typedef PA5_SPI,PA6_SPI,PA7_SPI;

	GPIOA_CLOCK_ENABLE();

	PA5_SPI.PinNumber=5;
	PA5_SPI.Mode=Alternate_function;
	PA5_SPI.AlternateType=AF5;
	PA5_SPI.OutPutspeed=High_Speed;


	PA6_SPI.PinNumber=6;
	PA6_SPI.Mode=Alternate_function;
	PA6_SPI.AlternateType=AF5;
	PA6_SPI.OutPutspeed=High_Speed;

	PA7_SPI.PinNumber=7;
	PA7_SPI.Mode=Alternate_function;
	PA7_SPI.AlternateType=AF5;
	PA6_SPI.OutPutspeed=High_Speed;

	GPIO_Initialization(GPIOA,&PA5_SPI);
	GPIO_Initialization(GPIOA,&PA6_SPI);
	GPIO_Initialization(GPIOA,&PA7_SPI);


	GPIO_Configure_Typedef CS_Pin_Config;

	CS_Pin_Config.PinNumber=pin0;
	CS_Pin_Config.Mode=OUTPUT;
	CS_Pin_Config.OutPutspeed=High_Speed;

	GPIO_Initialization(GPIOA,&CS_Pin_Config);

	GPIO_WritePin(GPIOA,&CS_Pin,Set);

	SPI_Enable_Clock(spi1);

	SPI_ConfigTypedef cSPI1;

	cSPI1.mode=Master_mode;
	cSPI1.slaveManagement=software_slave;
	cSPI1.baud=FCLK_32;
	cSPI1.CPHA=CPHA0;
	cSPI1.CPOL=CPOL0;
	cSPI1.LSBFirst=MSB_First;
	cSPI1.DMA_Enable=SPI_DMA_Enable;


	BSP_SPI_Config(SPI1,&cSPI1);


	__BSP_DMA2__CLOCK_ENABLE();

	SPI_TX_DMA.DMA_Channel=Channel2;
	SPI_TX_DMA.CircularMode=SingleTransfer;
	SPI_TX_DMA.MemorySize=byte;
	SPI_TX_DMA.PerpheralSize=byte;
	SPI_TX_DMA.MemoryIncMode=incMode;
	SPI_TX_DMA.PeripheralIncMode=SingleTransfer;
	SPI_TX_DMA.Direction=memory2Peripheral;
	SPI_TX_DMA.InterruptEnable=InterruptEnbaled;
	SPI_TX_DMA.TransferCompleteInterrupt=TransferComplet;
	SPI_TX_DMA.DMAStream=dma2stream2;
	//SPI_TX_DMA.PeripheralController=PeripheralController;
	BSP_DMA_Init(DMA2_Stream2, &SPI_TX_DMA);



	while(1)
	{
		GPIO_WritePin(GPIOA,&CS_Pin,Reset);

		BSP_DMA_Transfer_Single_Buffer(DMA2_Stream2, &SPI1->DR,(uint32_t)&SPI_TX,5);

		while(finished ==0){;}

		finished=0;

		GPIO_WritePin(GPIOA,&CS_Pin,Set);

		BSP_Delay(200);

	}
}

void clock_config(void)
{
	Clock_Config_Typedef clockConfig;

	clockConfig.PLL_M= 4;
	clockConfig.PLL_N= 200;
	clockConfig.PLL_P= 4;

	clockConfig.AHB1Prescaler=AHB1_Prescaler1;
	clockConfig.APB1Prescaler=APB1_Prescaler2;
	clockConfig.APB2Prescaler=APB2_Prescaler1;

	clockConfig.clockSourc=External_Oscillator;
	clockConfig.flash_latency= Three_wait_state;

	Clock_Configuration(&clockConfig);
}

void DMA2_Stream2_handler(void)
{
	if((DMA2->LISR & DMA_LISR_TCIF2)==DMA_LISR_TCIF2)
	{
		finished=1;
	}

}
